Redmine - Feature #3463

Export all wiki pages to PDF
2009-06-08 17:19 - Michael Diederich

Status: Closed Start date: 2009-06-08
Priority: Low Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Wiki Estimated time: 0.00 hour
Target version: 1.4.0

Resolution: Fixed

Description

Hi,

I would like to export Wiki-Pages to a PDF or DOC-Format. This request is a little bit similar to #3228

| also request, to export a whole wiki into a single page. It could be a multipage-documentation as a handout or something else.

Thanks,

Michael

Related issues:

Related to Redmine - Feature #401: Add pdf export for WIKI page Closed

Has duplicate Redmine - Feature #5000: Export all wiki pages Closed 2010-03-05

Associated revisions

Revision 8734 - 2012-01-30 19:42 - Jean-Philippe Lang
Adds export of all wiki pages to a PDF file (#3463).

History

#1 - 2009-06-09 09:02 - Patrice Bouillet

+1

This is one of the features | miss the most. A good PDF export of selected Wiki Pages would really be very very useful so that a separate
documentation does not have to be created somewhere else.

#2 - 2009-06-15 07:21 - Henrik Jondell

+1

this would be a very nice feature, making wiki's even more useful.
#3 - 2009-06-19 15:38 - Konstantin Ershov
+1

It's very useful feature.

#4 - 2009-07-16 17:46 - Guillermo Gémez
+1

i really would like to have this one...

#5 - 2009-08-05 15:45 - Andrey Kostrov

+1

Very useful for me.

#6 - 2009-08-06 11:24 - Benjamin Baroukh

+1. Nice because we are still working with people who likes paper...
#7 - 2009-08-07 12:10 - rupert thurner

how can one vote? by watching it? or by doing +17?

#8 - 2009-08-31 11:20 - Michael Aye

+1
| am doing telecon and meeting minutes with the wiki. But sometimes minutes need to be distributed to circles outside our workgroup. Exactly then a
pdf export would be great. To just have really 'paper’ versions only when it's absolutely necessary.

#9 - 2009-09-05 18:41 - Brian Finch

+1 Extremely useful feature

#10 - 2009-10-21 01:02 - Aleksey Timohin

+1
it would be very nice to allow export wiki in single/multiple document(s) starting from current page with all children included
so, it allows to export whole wiki, and also allows to handle single page export.

multiple documents f.e. can be provided in archive.

#11 - 2009-11-05 13:59 - Philippe Lambert

+1

#12 - 2009-11-18 20:58 - Enderson Maia

Maybe this could help - http:/github.com/mbleigh/princely

#13 - 2009-11-26 12:26 - Tiago Alves

+1

As stated multiple times above, it would also be nice to have the images inline and to be able to select which wiki pages to include in the PDF
generation. And while we're at it, it would also be nice to be able to store "profiles” for exports. This way we could define that for the profile "User
Documentation" we would always export the wiki pages UserDoc1 and UserDoc2 but not DevDoc1 for instance.

#14 - 2009-11-26 13:43 - Kamil .

Tiago Alves wrote:

+1

As stated multiple times above, it would also be nice to have the images inline and to be able to select which wiki pages to include in the PDF
generation. And while we're at it, it would also be nice to be able to store "profiles” for exports. This way we could define that for the profile "User
Documentation" we would always export the wiki pages UserDoc1 and UserDoc2 but not DevDoc1 for instance.

+1
Nice idea

#15 - 2009-12-03 05:08 - Billy T
+1
Maybe rtf is easier than doc.

#16 - 2010-04-02 14:24 - Eric Voisard

+1
Wouldn't this feature be a good candidate for release 1.07...

#17 - 2010-04-15 21:27 - Pieter Smith

+1

Our redmine server is self-hosting:
1. The server installation itself is a working copy of the self-hosted GIT repository.
2. All documentation and knowledge of the server goes into the server project's wiki.
3. All server issues goes into the server project's issue list.

4. Etc...

Replicating or recovering the server simply is a question of cloning the GIT repository. Until the server is back up and running however, the wiki with
all the knowledge is unavailable. While recovering the server an off-line viewable PDF of the wiki pages would be DAMN handy!
#18 - 2010-04-16 16:30 - Yuki Kita

+1

#19 - 2010-04-16 20:25 - minkbear minkbear

+1

#20 - 2010-05-22 23:41 - Yaroslav Matsera

+1

#21 - 2010-05-26 15:46 - James Rowe

+1 We use the wiki for documentation, but we have a need to 'export' a wiki to pdf to provide instructions to users who can't access the system (offsite
or offline)

#22 - 2010-05-26 15:53 - Carmen De Vito

+1 on this. | use this for user docs, and would be really helpful if | can sent them out as a PDF as well.

#23 - 2010-05-27 09:12 - Kirill Ponomarev

+1

#24 - 2010-05-27 22:08 - Ben Coleman

+1

#25 - 2010-05-28 09:18 - Jerome Vanthournout

+1

#26 - 2010-06-10 22:21 - Jared Hellman

+1

#27 - 2010-06-22 17:54 - Michael Konig

+1

#28 - 2010-06-24 06:31 - Paul H

+1

#29 - 2010-08-06 11:37 - Moritz Voss

+1 and made a small donation.

Document export to PDF and preferrably HTML (for post-processing) would be really good to have.

#30 - 2010-08-06 22:25 - Terence Mill

+1

#31 - 2010-09-02 13:44 - Mark Bednarski

+1

#32 - 2010-09-17 16:26 - Marton Danoczy

+1

#33 - 2010-09-20 17:52 - Anonymous

+1

#34 - 2010-09-22 13:10 - Anonymous

+1

#35 - 2010-10-04 17:33 - Arnaud Martel
- File redmine_pdf_wiki.tgz added
| have an alpha version for this feature. It's more a proof of concept than a production's plugin but it may give ideas to another developer...
You are welcome if you want to test this plugin/patch but be aware that you need to have knowledges with LINUX, Apache+Passenger,
WKHTMLTOPDF and RUBY (I didn't make a lot of tests so you may have to adapt the source code to you own needs...)

Introduction

This plugin allows to export WIKI page(s) to .PDF file, using WKHTML2PDF, with images and TOC (need to remove --no-outline from command line)

Setup

1. Install wkhtmI2pdf
via pdfkit:

e gem install pdfkit
e pdfkit --install-wkhtmltopdf

Directly from wkhtml2pdf website

¢ http:/code.google.com/p/wkhtmitopdf/downloads/list

2. Install plugin

Install redmine_pdf_wiki with:

e cd <redmine directory>/vendor/plugins
e tar xvzf redmine_pdf_wiki.tgz

No DB migration is required...
3. Patch REDMINE to add link 'Export PDF’

Edit <redmine directory>/app/view/wiki/show.rhtml:

<%= f.link_to 'HTML', :url => {:page => @page.title,
<%= f.link_to 'TXT', :url => {:page => (@page.

should be
<%= f.link_to 'HTML', :url => {:page => @page.title,
<%= f.link_to 'TXT', :url => {:page => (@page.
<%= f.link_to('PDF', :url => {:controller =>

title,

title,
'wikitopdf',

Then edit <redmine directory>/app/view/wiki/special_page_index.rhtml:

<%= f.link_to 'Atom', :url => {:controller =>
ki_edits => 1, :key => User.current.rss_key} %>
<%= f.link_to('HTML', :url => {:action =>

rt_wiki_pages, @project) %>

should be

<%= f.link_to
ki_edits => 1,

'Atom',
:key => User.current.rss_key}

%>

<%= f.link_to('HTML', :url => {:action =>
rt_wiki_pages, @project) %>
<%= f.link_to('PDF', :url => {:controller =>

urrent.allowed_to? (:export_wiki_pages, @project)

4 Configure Passenger

If you are using Apache + Passenger, you have to change passenger settings to add:

e PassengerUseGlobalQueue on

'special’,

turl => {:controller =>

'special’,

'projects’,

:page

'projects’,

:page

'wikitopdf',
%>

:version => (@content.version}
:version => @content.version}

:version => (@content.version}
:version => @content.version}

raction =>

raction =>

raction =>

%>
%>

%>
%>

action => :id

'export', :page => @page.title,

'activity', :id => @project, :show_wi

=> 'export'}) if User.current.allowed_to? (:expo

'activity', :id => @project, :show_wi

=> 'export'}) if User.current.allowed_to? (:expo

'export', :id => @project}) 1if User.c

If you are using another web server configuration, you may have to configure something to allow a web request to recursively call your web server (if

you have a blank page that takes an infinite time to be loaded...)
5. Restart your web server

6. Configure REDMINE with your web browser

If everything is OK, you should see WikiToPdf plugin plugin in the plugin list (Administration -> Plugins)
Then, you have to configure the plugin:

e command line to run wkhtmltopdf (default value should be OK in most cases)
¢ temporary directory where .pdf files will be generated. You should clean it periodicaly (using crontab, for example)

History

0.0.1: Initial release
#36 - 2010-10-04 18:29 - Colan Schwartz
Arnaud Martel wrote:

| have an alpha version for this feature.

Does it take advantage of the Redmine code that already does this for issues?
| suggested that we do this over at #401. Perhaps this issue should be blocked by that one, until it is complete.

#37 - 2010-10-04 22:44 - Arnaud Martel

No (see #401 for more details). Wiki pages may contain complex HTML code and/or specific macros (that's why export to pdf is so difficult...)
#38 - 2010-10-05 13:42 - Jose Garcia
Arnaud Martel wrote:

| have an alpha version for this feature.
Thanks for the plugin. | tried with latest version of redmine but get

ActionController::MissingFile (Cannot read file /Applications/redmine-1.0.2-0/apps/redmine/tmp/051nhl5kr.pdf) :
vendor/plugins/redmine_pdf_wiki/app/controllers/wikitopdf_controller.rb:61:in “to_pdf'
vendor/plugins/redmine_pdf_wiki/app/controllers/wikitopdf_controller.rb:10:in " export'

Rendering /Applications/redmine-1.0.2-0/apps/redmine/public/500.html (500 Internal Server Error)

| logged the wkhtmltopdf command launched and executing it manually from a terminal session the pdf is created correctly.

Is there any way to get more verbose logging to identify what's the problem? (sorry, my knoweledge of ruby/rails is quite limited)

Thanks in advance

#39 - 2010-10-05 14:11 - Arnaud Martel

Jose,

Your wkhtmltopdf command fails (at least when run from redmine).

Check if your web server has read/write access on your temp directory (/Applications/redmine-1.0.2-0/apps/redmine/tmp) and/or try to run the
command from a terminal AS your web server.

#40 - 2010-10-29 10:24 - Hugues Romain

If your installation uses the redmine_wiki_permissions plugin, in the step 3 of installation you must edit
/vendor/plugins/redmine_wiki_permissions/app/views/wiki/show.rhtml.erb too.

Add the line

<span><%-= link_to('PDF', {:controller => 'wikitopdf', :action => 'export', :page => @page.title, :id => Herve Harster}) %></span>
after

<span><%-= link_to 'HTML', {:page => @page.title, :export => 'html', :version => @content.version}, :class => 'html' ></span>
<span><= link_to 'TXT', {:page => @page.title, :export => 'txt', :version => @content.version}, :class => 'text' %></span>
#41 - 2011-02-01 17:47 - Eduardo Bento Rocha

| have same problem, but downgrading the wkhtmltopdf to 0.99 its works fine.

#42 - 2011-02-04 13:26 - Christian Mayr

Christian Raschko made the DocPu-Plugin, which makes this IMHO obsolete:
http://www.redmine.org/plugins/redmine_doc_pu

#43 - 2011-03-16 13:28 - Joshua Villagomez

Are we should DocPu obseletes this feature request? Doesn't it require an admin to export wiki to pdfs? | think ideally any user should be able to click
on any wiki and export to PDF. | wonder if Doc-Pu is filling all those needs.

#44 - 2011-03-16 19:49 - Terence Mill

Yes, your absolutly right. DocPu can't do that and is far to complicated and error prone for an plain "click pdf link" to export the site wiki site you see to
pdf.

The post or Arnaud Martel looks very promissing the only thing what is ugly that he doesn't use the hooks to add in the new pdf link in the wiki site.
Isn't there a hook, i know that at least for issue list exports there is one, but for wiki site display - dunno ??

Someone knows?

#45 - 2011-03-16 19:52 - Terence Mill
Arnaud Calmettes

Can u provide this nice piece of plugin on your github account?
Tx for ur contribution!

#46 - 2011-03-31 12:28 - Carl D'Halluin
Hi

| had some issues with this plugin. Patch is below.
Also i made sure that the exported pdf had a useful filename (project name, page name in the pdf filename)

Where can | contribute this code such that every redmine user can now export wiki pages to pdf.
This is just great. This was my last reason to use Jira over Redmine.

Apply the diff to:
redmine_pdf_wiki/app/controllers/wikitopdf_controller.rb

55¢55,56
< args << " + url_for(:controller => 'wiki', :action => 'index’, :id => @page.project, :page => @page.title) + "™

#args << ™" + url_for(:controller => 'wiki', :action => 'index’, :id => @page.project, :page => @page.title) + ™

" m

args << " + url_for(:controller => 'wiki', :action => 'show', :project_id => @page.project, :id => @page.title) +
61,63c62,64
< send_file pdfname, :filename => "export.pdf",
< ‘type => "application/pdf’,
< :disposition => 'inline’
export_file_name = @page.project.name +"___ " + @page.title + ".pdf"

send_file pdfname, :filename => export_file_name,
‘type => "application/pdf'

#47 - 2011-03-31 12:29 - Carl D'Halluin

readable diff

55¢55,56

< args << '""' + url_for(:controller => 'wiki', :action => 'index', :id => @page.project, :page => (@page.
title) ¢ VDU

> #args << '"' + url_for(:controller => 'wiki', :action => 'index', :id => @page.project, :page => @page
.title) ¢ VDU
> args << '"' + url_for(:controller => 'wiki', :action => 'show', :project_id => @page.project, :id => @
page.title) + '"!
61,63c62,64

< send_file pdfname, :filename => "export.pdf",

< :type => 'application/pdf',

< :disposition => 'inline'

> export_file_name = (@page.project.name + " " + @page.title + ".pdf"
> send_file pdfname, :filename => export_file_name,

:type => 'application/pdf'
#48 - 2011-03-31 22:25 - Arnaud Martel
Sorry for the delay,

Terence Hersbach,
| just created another repo on github to host my plugin: https:/github.com/amartel/redmine_pdf_wiki

Carl Malherbe,

| have integrated the support for redmine 1.1.x (changing parameters for the wiki controller) but | didn't the generated .pdf filename
(@page.project.name and @page.title may contain bad chars for a filename).

Feel free to contribute...

#49 - 2011-04-06 12:42 - Tino Naphtali

First of all, thank you for this plugin.

For information: The wkhtmltopdf package of Debian squeeze is not compiled against the correct QT libraries, so | have to use the static build.
Unfortunately the plugin only generates a PDF with a 404 error page. The reason is probably due to a wrong URL of the wiki page.
Passed to wkhtmltopdf is the URL:

https://<server>/wiki/show/<wiki_page>?project_id=<projekt>

The correct URL of the Wiki page is:

https://<server>/projects/<projekt>/wiki/<wiki_page>

I'm not a Ruby programmer and therefore can not adjust the plugin myself. | think the file app/controllers/wikitopdf_controller.rb has to be modified
(probably at line 24 and/or 55).

Thanks in advance.

#50 - 2011-04-11 09:10 - Tino Naphtali

Excuse me. | had not noticed that the patch (changing parameters for the wiki controller) is already included in the GIT sources. | use the version
1.0.1. So | had only to undo the changes of the patch by Carl.

Tino Naphtali wrote:

(-]

Unfortunately the plugin only generates a PDF with a 404 error page. The reason is probably due to a wrong URL of the wiki page.

(-]

#51 - 2011-08-19 22:13 - Josh Davidson

+1

#52 - 2011-10-19 08:24 - Lucy Yevseyeva
+1 60560

#53 - 2011-10-19 10:58 - Pieter Smith
I think that most use-cases can already be satisfied with the DocPu plugin

#54 - 2011-10-19 14:38 - Terence Mill

For us docu in to much error prone. We can't get i run for a bigger wiki site (40 sites), there to many probelms with specific macros, locales and latex
template details.
Renedering the wiki site as "frameless" html print preview and then converting html to pdf, would be less error prone.
Or ar least docu should come more "configured" and tested.

#55 - 2011-10-20 11:06 - Pieter Smith

A'h lovely... Another parallel effort then? This can reasonably easily be made as a plugin. Question is: Should the effort be piled onto fixing /

improving DocPu, or by making a new plugin.

We can also make good use of such simplification. Anybody interested in helping to fund the effort?

#56 - 2011-10-20 12:16 - Terence Mill

The way is leardy gone in https:/github.com/amartel/redmine_pdf_wiki

#57 - 2011-11-30 17:44 - Matias Basso

Hi everyone:

I'm using Redmine v-1.2.1 and wkhtmltopf v-0.11.0, and i have an issue. When | open the pdf, the title's letters are overlapping. Everything else is ok.

| hope someone can help me, if is needed more info don't doubt in ask .Thx

#58 - 2011-12-23 16:01 - Cassiano Monteiro

+1

#59 - 2012-01-30 19:45 - Jean-Philippe Lang
- File wiki_pdf export.png added

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version set to 1.4.0

- Resolution set to Fixed

Feature added in r8734. You can now export all the wiki pages to a single PDF.
The export link is available on the wiki pages index. The PDF contains hierarchical bookmarks for easy navigation:
#60 - 2012-01-30 21:11 - Jean-Philippe Lang

Comptes

Mon compte

Cet écran vous permet de madilier les paramétres de volre co

Notifications par mail

Si Notifications par mail est cochd, vous recevrez des notific
(demande aruutéﬁ ou modifiée, nouveauy documants_.. ).

Sl la case est décochde, vous recevrez seulement les notificat
&léments que vous avez placés en survelllance (cad. demand

Mot de passe

Pour modifier volre mol de passe, tlapez volre ancien mat de g
comprise entre 4 et 12 caractéres.

Sivatre comple utilise un moyen d'authentification extermne (LLC

Mon_comple.png

Ma page

Cette page vous permet d'afficher plusieurs informations & pra

- Demandes qui me sont assignées

- Subject changed from Export (all) Wiki-Pages to PDF/DOC to Export all wiki pages to PDF

#61 - 2012-01-31 00:34 - Terence Mill

2025-05-01

8/9


https://github.com/amartel/redmine_pdf_wiki
https://www.redmine.org/projects/redmine/repository/svn/revisions/8734

Great!

#62 - 2012-03-15 15:31 - Franck Samson
Great!
| use the redmine 1.3.2.stable.9237 and | have the pdf export on the wiki pages but | don't have export all wiki pages. How to configure this?

#63 - 2012-03-15 15:57 - Etienne Massip

The target version is set to 1.4.0.

#64 - 2012-03-15 16:05 - Franck Samson

Great, | have to wait just few days. :)

#65 - 2012-06-06 08:36 - Franck Samson

| have updated my redmine to 1.4.3 but the pdf export give me just the first page... Is there anything to Install/configure to have all wiki pages into the
pdf file?

#66 - 2012-06-06 18:28 - Jean-Philippe Lang

Make sure you're using the export link on the wiki page index, not on a wiki page.

#67 - 2012-06-07 11:58 - Franck Samson
That's right, thanks.

Is it possible to have in futur version all wiki links clickable in the PDF file ?

Files
redmine_pdf_wiki.tgz 3.82 KB 2010-10-04 Arnaud Martel
wiki_pdf_export.png 26.7 KB 2012-01-30 Jean-Philippe Lang
